-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Mon Jan 07 11:11:25 2008

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

--  Entity Declaration

ENTITY Reset_box IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		G_CLK1 : IN STD_LOGIC;
		G_CLK2 : IN STD_LOGIC;
		Power_Good : IN STD_LOGIC;
		G_Reset1 : OUT STD_LOGIC;
		G_Reset2 : OUT STD_LOGIC;
		Soft_Reset : IN STD_LOGIC
	);
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END Reset_box;

--  Architecture Body

--Ez a reset dobozka a kt bels rajeltartomnyban mkd modulok reset jelt lltja el.
--Az egyiki rajeltartomny az ADC adatok kiolvassi tartomnya (G_Clk2: 10MHz) a msik az
--adatok soros kikldse (G_Clk1: 66MHz).

ARCHITECTURE Reset_box_architecture OF Reset_box IS

	signal soft_reset_signal: std_logic;
	signal reset_counter: std_logic_vector(7 downto 0);		--szmolja a resetidt
	signal reset_counter_en: std_logic:= '1';				--engedlyezi a szmllt
	
BEGIN
	
--process1: Reset szmll. Amg a szmll kisebb 127-nl reset llapot van.
	process(G_CLK1,Power_Good)
	begin
		if Power_Good= '0' then
			soft_reset_signal <= '0';
			reset_counter <= (others => '0');
			reset_counter_en <= '1';
		else
			if Rising_Edge(G_CLK1) then
				soft_reset_signal <= Soft_Reset;	--Soft_Reset szinkronizlsa
				if soft_reset_signal= '1' then
					reset_counter <= (others => '0');
					reset_counter_en <= '1';
				else
					if reset_counter_en= '1' then
						reset_counter <= reset_counter + 1;
						if reset_counter(7)= '1' then
							reset_counter_en <= '0';
						end if;
					end if;
				end if;
			end if;
		end if;
	end process;
--process2: Reset jel a G_CLK1-el mkd dobozkknak
	process(G_CLK1,reset_counter)
	begin
		if reset_counter(7)= '0' then
			G_Reset1 <= '1';
		elsif Rising_Edge(G_CLK1) then
			G_Reset1 <= '0';
		end if;
	end process;
--process3: Reset jel a CLK2-el mkd dobozkknak
	process(G_CLK2,reset_counter)
	begin
		if reset_counter(7)= '0' then
			G_Reset2 <= '1';
		elsif Rising_Edge(G_CLK2) then
			G_Reset2 <= '0';
		end if;
	end process;
END Reset_box_architecture;
