-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Fri Jan 04 10:24:49 2008

LIBRARY ieee;
USE ieee.std_logic_1164.all;

--  Entity Declaration

ENTITY Transmitter_box IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		Tx_Data : IN STD_LOGIC_VECTOR(7 downto 0);
		G_Clk : IN STD_LOGIC;
		Tx_Data_Ready : IN STD_LOGIC;
		Tx_Data_Type : IN STD_LOGIC;
		Reset : IN STD_LOGIC;
		Tx_Clk : OUT STD_LOGIC;
		Serial_Out : OUT STD_LOGIC;
		Transmitter_Ready_For_Data_Sending : OUT STD_LOGIC;
		Transmitter_Ready_For_Status_Sending : OUT STD_LOGIC
	);
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END Transmitter_box;

--  Architecture Body

ARCHITECTURE Transmitter_box_architecture OF Transmitter_box IS

	signal shiftreg: std_logic_vector(10 downto 0);
	signal tx_ready_pipe : std_logic_vector (8 downto 0) := (others => '0');
	
BEGIN
--	process1: shiftregiszter tpllsa adatokkal
	process(G_Clk,Reset)
	begin
		if Reset= '1' then
			shiftreg <= (others => '1');
		elsif Rising_Edge(G_Clk) then
			-- the shiftreg will shift out the message bit-by-bit
			-- when the tx_req signal is asserted, the shiftregister
			-- is loaded with the data/control, the start bits and
			-- stop bit.
			if Tx_Data_Ready= '1' then
				shiftreg(10) <= '1';
				shiftreg(9 downto 2) <= Tx_Data;
				shiftreg(1) <= Tx_Data_Type;
				shiftreg(0) <= '0';
			else
				shiftreg <= '1' & shiftreg(10 downto 1);
			end if;
		end if;
	end process;
	Serial_Out <= shiftreg(0);
	Tx_Clk <= not G_Clk;
--	process2: Foglaltsg jelzse
	process(G_Clk,Reset)
	begin
		if Reset= '1' then
			Transmitter_Ready_For_Data_Sending <= '0';
			Transmitter_Ready_For_Status_Sending <= '0';
			tx_ready_pipe <= "000000000";			
		elsif Rising_Edge(G_Clk) then
			-- the tx_ack_pipe will generate the acknowledgement signal
			-- by changing the value, which is loaded when the tx_req is
			-- asserted, one can define the delay of the tx_ack relative
			-- to tx_req
			if Tx_Data_Ready = '1' then
				tx_ready_pipe <= "100000000";
			else
				tx_ready_pipe <= '0' & tx_ready_pipe(8 downto 1);
			end if;
			--A ktfle jel azrt szksges,mert norml adat kldsnl mindg elbb kiolvasok egy adatot
			--a nyolcbites kimeneti FIFO-bl,aztn adom t a transmitter doboznak. Az jelez ha megette
			--az adatot, ekkor kezddhet egy jabb olvass a kimeneti FIFO-bl, majd adat tads...
			--Teht kiadhatom hamarabb a Transmitter Ready jelet, mert amg a Sending_Controler beolvassa
			--a kvetkez adatot, a Transmitter ki tudja kldeni a stop bitet.
			--Viszont Adatblokk s Statussz felkldsnl egyms utn kldm a bjtokat, nincs a Transmitter
			--Ready jel utn sznet(olvass). Igy ilyenkor, hogy ne rjam fell a stop bitet, ksbb kell
			--kiadni a Transmitter Ready jelet egy rajel ciklussal.
			Transmitter_Ready_For_Data_Sending <= tx_ready_pipe(1);
			Transmitter_Ready_For_Status_Sending <= tx_ready_pipe(0);
		end if;
	end process;
END Transmitter_box_architecture;
