-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.


-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Sat Oct 03 10:39:54 2009

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

--  Entity Declaration

ENTITY Trigger_box IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		G_CLK : IN STD_LOGIC;
		G_Reset : IN STD_LOGIC;
		G_Trigger : IN STD_LOGIC;
		Trigger_Out : OUT STD_LOGIC;
		ADC_Memory_Write : OUT STD_LOGIC;
		ADC_Memory_Read : OUT STD_LOGIC;
		Last_Data : IN STD_LOGIC;
		MB_Busy : OUT STD_LOGIC;
		End_Of_Data_Block : IN STD_LOGIC;
		FE_Command_Read_Req : IN STD_LOGIC;
		FE_Command_Read : OUT STD_LOGIC;
		Working_Parameters : IN STD_LOGIC_VECTOR(39 downto 0);
		G_Trigger_Counter : OUT STD_LOGIC_VECTOR(31 downto 0)
	);
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END Trigger_box;

--  Architecture Body

ARCHITECTURE Trigger_box_architecture OF Trigger_box IS

   	type state_type is (Idle,Trigger_Confirmation,ADC_Data_Read,ADC_Data_Send,FE_Command_Read_Req_Ack_State);

    signal next_state, current_state: state_type;

--Bels jelek
	signal trigger_counter: std_logic_vector(31 downto 0);

--Segdjelek ms rajeltartomnybl jv jelek szinkronizlshoz
	signal trigger_signal: std_logic;				--Trigger jel szinkronizlsa.
	signal FE_command_read_req_signal: std_logic;	--Parancs rkezett jelzs szinkronizlsa.
	signal end_of_data_block_signal: std_logic;		--Adatblokk vge jelzs szinkronizlsa(Busy logikhoz).

	signal Data_Collecting_Mode: std_logic;
	signal Reset_Command: std_logic_vector(2 downto 0);
	signal MB_Included: std_logic;
	
BEGIN

	--A trigger szmll rtknek tovbbadsa
	G_Trigger_Counter <= trigger_counter;

-----Kls jelek szinkronizlsa-----
--process1:	jelek szinkronizlsa G_CLK-hoz
	process(G_CLK,G_Reset)
	begin
		if G_Reset= '1' then
			trigger_signal <= '0';
			FE_command_read_req_signal <= '0';
			end_of_data_block_signal <= '0';
			Data_Collecting_Mode <= '0';
			Reset_Command <= (others => '0');
			MB_Included <= '0';
		elsif Rising_Edge(G_CLK) then
			trigger_signal <= G_Trigger;						--A Trigger jel szinkronizlsa.
			FE_command_read_req_signal <= FE_Command_Read_Req;	--Parancs rkezett jel szinkronizlsa.
			end_of_data_block_signal <= End_Of_Data_Block;		--Blokk vge jel szinkronizlsa.
			Data_Collecting_Mode <= Working_Parameters(33);
			Reset_Command <= Working_Parameters(28 downto 26);
			MB_Included <= Working_Parameters(0);
		end if;
	end process;
-------------------------------------------------
--process2: llapotregiszter rtkads
	process(G_CLK,G_Reset)
    begin
		if G_Reset= '1' then
            current_state <= Idle;
		elsif Rising_Edge(G_CLK) then
	    	current_state <= next_state;
		end if;
    end process;
-------------------------------------------------
--process3: Bers, llapotgp lersa
	process(current_state,trigger_signal,MB_Included,Data_Collecting_Mode,FE_command_read_req_signal,
			Last_Data,end_of_data_block_signal)
	begin
		FE_Command_Read <= '0';
		case current_state is
			--Ebbl az llapotbl akkor lp tovbb, ha triggert kap, a krtya engedlyezve van,
			--s adatgyjts mdba van lltva a rendszer.
			when Idle =>
				if (trigger_signal and Data_Collecting_Mode and MB_Included)= '1' then
					next_state <= Trigger_Confirmation;
				elsif FE_command_read_req_signal= '1' then
					next_state <= FE_Command_Read_Req_Ack_State;
				else
					next_state <= Idle;
				end if;
			--Trigger megersts. Elfordul, hogy csak egy rvid impulzus jelenik meg trigger helyett.
			--Hogy erre ne tudjon elindulni az adatgyjts, megnzem mg egy rajel mlva, hogy valban
			--van-e trigger. Ha igen elindul az adatgyjts, ha nem, visszatrek alapllapotba.
			when Trigger_Confirmation =>
				if trigger_signal= '1' then
					next_state <= ADC_Data_Read;
				else
					next_state <= Idle;
				end if;
			--Adatok kiolvassa. Ha az sszes adatot kiolvastam (last_data egybe billen) vge
			--az ADC memrik kiolvassnak. Megvrom mg az adatok kicsorognak a soros vonalon.
			when ADC_Data_Read =>
				if Last_Data= '1' then
					next_state <= ADC_Data_Send;
				else
					next_state <= ADC_Data_Read;
				end if;
			--Adatok kikldse. Ha az sszes adatot kikldtem (end_of_data_block egybe billen)
			--vge a kiolvassnak, visszatrek alapllapotba.
			when ADC_Data_Send =>
				if end_of_data_block_signal= '1' then
					next_state <= Idle;
				else
					next_state <= ADC_Data_Send;
				end if;
			--Ha a Receiver parancs rkezst jelzi, vissza kell igazolni, mert a
			--visszaigazol jelek S kapcsolatban vannak.
			when FE_Command_Read_Req_Ack_State =>
				FE_Command_Read <= '1';		--Parancs visszaigazolsa.
				if FE_command_read_req_signal= '0' then
					next_state <= Idle;
				else
					next_state <= FE_Command_Read_Req_Ack_State;
				end if;
		end case;
	end process;
-------------------------------------------------
--process4: rtkadas a jeleknek
	process(G_CLK,G_Reset)
	begin
		if G_Reset= '1' then						--Alaprtkek belltsa
			Trigger_Out <= '0';
			ADC_Memory_Write <= '0';
			ADC_Memory_Read <= '0';
			trigger_counter <= (others => '0');
			MB_Busy <= '0';
		elsif Rising_Edge(G_CLK) then
			--Trigger kiadsa
			if current_state= Trigger_Confirmation and trigger_signal= '1' then
				Trigger_Out <= '1';						--Trigger jel kiadsa.
			else
				Trigger_Out <= '0';
			end if;
			--ADC_Memria rs/olvass jelek belltsa.
			if (current_state= Trigger_Confirmation and trigger_signal= '1') or
			   current_state= ADC_Data_Read then
				ADC_Memory_Write <= '0';
				ADC_Memory_Read <= '1';
			else
				ADC_Memory_Write <= '1';
				ADC_Memory_Read <= '0';
			end if;
			--MB Busy ellltsa
			if current_state= Trigger_Confirmation and trigger_signal= '1' then
				MB_Busy <= '1';						--A trigger jel bebillenti a MB Busy jelet.
			end if;
			--Vrakozs llapot
			if current_state= Idle then
				MB_Busy <= '0';						--A blokk vge jel kikapcsolja a MB Busy jelet.
			end if;
			--Trigger szmll belltsa
			if current_state= Trigger_Confirmation then
				if trigger_signal= '1' then			--Ha megjtt a trigger jel, nvelem a trigger szmllt.
					trigger_counter <= trigger_counter + 1;
				end if;
			elsif current_state= FE_Command_Read_Req_Ack_State and Reset_Command= "001" then
				trigger_counter <= (others => '0');	--Ha trigger szmll reset parancsot kaptam, trlm a szmllt.
			end if;
		end if;
	end process;
END Trigger_box_architecture;
